Перейти к основному содержимому

Интеграция с React

Подсказка

Это руководство предполагает знакомство с концепциями и паттернами React. Для подготовки обратитесь к документации React.

DHTMLX Kanban совместим с React. Полный пример кода доступен на GitHub.

Создание проекта​

К сведению

Перед созданием нового проекта установите Vite (опционально) и Node.js.

Создайте базовый проект React (или React с Vite). Назовём проект my-react-kanban-app:

npx create-react-app my-react-kanban-app

Установка зависимостей​

Перейдите в директорию созданного приложения:

cd my-react-kanban-app

Установите зависимости и запустите dev-сервер с помощью одного из менеджеров пакетов:

yarn
yarn start
npm install
npm run dev

Приложение будет работать на локальном адресе (например, http://localhost:3000).

Создание Kanban​

Остановите dev-сервер и установите пакет Kanban.

Шаг 1. Установка пакета​

Скачайте пробный пакет Kanban и выполните шаги, описанные в файле README. Пробная версия доступна в течение 30 дней.

Шаг 2. Создание компонента​

Создайте компонент React, добавляющий Kanban в приложение. Добавьте новый файл в директорию src/ и назовите его Kanban.jsx.

Импорт исходных файлов​

Откройте Kanban.jsx и импортируйте исходные файлы Kanban. Пути к импортам зависят от версии пакета:

  • Для PRO-версии, установленной из локальной папки:
Kanban.jsx
import { Kanban, Toolbar } from 'dhx-kanban-package';
import 'dhx-kanban-package/dist/kanban.css';

Если пакет поставляется с минифицированными исходными файлами, импортируйте CSS-файл как kanban.min.css.

  • Для пробной версии:
Kanban.jsx
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import "@dhx/trial-kanban/dist/kanban.css";

В этом руководстве используется пробная версия Kanban.

Настройка контейнеров и инициализация Kanban​

Чтобы отобразить Kanban с Toolbar, создайте два контейнера и вызовите конструкторы. Следующий фрагмент кода связывает рефы и инициализирует компоненты внутри useEffect():

Kanban.jsx
import { useEffect, useRef } from "react";
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import '@dhx/trial-kanban/dist/kanban.css'; // подключение стилей Kanban

export default function KanbanComponent(props) {
let toolbar_container = useRef(); // инициализация контейнера для Toolbar
let kanban_container = useRef(); // инициализация контейнера для Kanban

useEffect(() => {
// инициализация компонента Kanban
const kanban = new Kanban(kanban_container.current, {});

// инициализация компонента Toolbar
const toolbar = new Toolbar(toolbar_container.current, {
api: kanban.api, // передача внутреннего API Kanban
// другие параметры конфигурации
});

return () => {
kanban.destructor(); // уничтожение Kanban
toolbar.destructor(); // уничтожение Toolbar
};
}, []);

return <div className="component_container">
<div ref={toolbar_container}></div>
<div ref={kanban_container} className="widget"></div>
</div>
}

Добавление стилей​

Добавьте стили для Kanban и его контейнера в основной CSS-файл:

index.css
/* specify styles for initial page */
html,
body,
#root {
height: 100%;
padding: 0;
margin: 0;
}

/* specify styles for Kanban and Toolbar container */
.component_container {
height: 100%;
margin: 0 auto;
}

/* specify styles for Kanban container */
.widget {
height: calc(100% - 56px);
}

Загрузка данных​

Чтобы наполнить Kanban данными, предоставьте набор данных. Создайте файл data.js в директории src/:

data.js
export function getData() {
const columns = [
{
label: "Backlog",
id: "backlog"
},
{
label: "In progress",
id: "inprogress"
},
// ...
];

const cards = [
{
id: 1,
label: "Integration with Angular/React",
priority: 1,
color: "#65D3B3",
start_date: new Date("01/07/2021"),
users: [3, 2],
column: "backlog",
type: "feature",
},
{
label: "Archive the cards/boards ",
priority: 3,
color: "#58C3FE",
users: [4],
progress: 1,
column: "backlog",
type: "feature",
},
// ...
];

const rows = [
{
label: "Feature",
id: "feature",
},
{
label: "Task",
id: "task",
}
];

return { columns, cards, rows };
}

Откройте App.js, импортируйте данные и передайте значения в новый компонент <Kanban/> через props:

App.js
import Kanban from "./Kanban";
import { getData } from "./data";

function App() {
const { columns, cards, rows } = getData();
return <Kanban columns={columns} cards={cards} rows={rows} />;
}

export default App;

Откройте Kanban.jsx и примените props к объекту конфигурации Kanban:

Kanban.jsx
import { useEffect, useRef } from "react";
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export default function KanbanComponent(props) {
let kanban_container = useRef();
let toolbar_container = useRef();

useEffect(() => {
const kanban = new Kanban(kanban_container.current, {
columns: props.columns, // данные для колонок
cards: props.cards, // данные для карточек
rows: props.rows, // данные для строк
rowKey: "type",
// другие параметры конфигурации
});

const toolbar = new Toolbar(toolbar_container.current, {
api: kanban.api,
// другие параметры конфигурации
});

return () => {
kanban.destructor();
toolbar.destructor();
};
}, []);

return <div className="component_container">
<div ref={toolbar_container}></div>
<div ref={kanban_container} className="widget"></div>
</div>
}

В качестве альтернативы данные можно загрузить после создания экземпляра с помощью setConfig() или parse() внутри useEffect():

Kanban.jsx
import { useEffect, useRef } from "react";
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export default function KanbanComponent(props) {
let kanban_container = useRef();
let toolbar_container = useRef();

let columns = props.columns;
let cards = props.cards;
let rows = props.rows;

useEffect(() => {
const kanban = new Kanban(kanban_container.current, {
columns: [],
cards: [],
rows: [],
rowKey: "type",
// другие параметры конфигурации
});

const toolbar = new Toolbar(toolbar_container.current, {
api: kanban.api,
// другие параметры конфигурации
});

kanban.setConfig({ columns, cards, rows });
// or kanban.parse({ columns, cards, rows });

return () => {
kanban.destructor();
toolbar.destructor();
};
}, []);

return <div className="component_container">
<div ref={toolbar_container}></div>
<div ref={kanban_container} className="widget"></div>
</div>
}

Компонент Kanban готов. При рендеринге элемента Kanban инициализируется с данными. Полный список поддерживаемых свойств конфигурации см. в справочнике API Kanban.

Обработка событий​

Действия пользователя в Kanban инициируют события. Подписывайтесь на события, чтобы реагировать на конкретные действия. Полный список см. в справочнике событий Kanban.

Откройте Kanban.jsx и расширьте вызов useEffect():

Kanban.jsx
// ...
useEffect(() => {
const kanban = new Kanban(kanban_container.current, {});

kanban.api.on("add-card", (obj) => {
console.log(obj.columnId);
});

return () => {
kanban.destructor();
};
}, []);
// ...

Запустите приложение, чтобы увидеть заполненную доску Kanban на странице.

Доска DHTMLX Kanban, инициализированная в приложении React, с заполненными колонками и карточками

Готовый проект доступен на GitHub.

Перейти к основному содержимому

Интеграция с Vue

Подсказка

Это руководство предполагает знакомство с концепциями и паттернами Vue. Для повторения знаний обратитесь к документации по Vue 3.

DHTMLX Kanban совместим с Vue. Полный пример кода для Vue 3 доступен на GitHub.

Создание проекта​

К сведению

Перед созданием нового проекта установите Node.js.

Следующая команда создаёт новый проект Vue:

npm create vue@latest

Команда запускает create-vue, официальный инструмент для создания проектов на Vue. Подробнее смотрите в разделе Vue.js Quick Start.

Назовём проект my-vue-kanban-app.

Установка зависимостей​

Перейдите в директорию приложения:

cd my-vue-kanban-app

Установите зависимости и запустите dev-сервер с помощью одного из менеджеров пакетов:

yarn
yarn start // or yarn dev
npm install
npm run dev

Приложение будет доступно на localhost (например, http://localhost:3000).

Создание Kanban​

Остановите dev-сервер и установите пакет Kanban.

Шаг 1. Установка пакета​

Скачайте триальную версию Kanban и следуйте инструкциям из файла README. Триальная версия доступна 30 дней.

Шаг 2. Создание компонента​

Создайте компонент Vue, который монтирует Kanban и Toolbar. Добавьте новый файл Kanban.vue в директорию src/components/.

Импорт исходных файлов​

Откройте Kanban.vue и импортируйте исходные файлы Kanban. Пути к импортам зависят от версии пакета:

  • Для PRO-версии, установленной из локальной папки:
Kanban.vue
<script>
import { Kanban, Toolbar } from 'dhx-kanban-package';
import 'dhx-kanban-package/dist/kanban.css';
</script>

Если пакет поставляется с минифицированными исходными файлами, импортируйте CSS-файл как kanban.min.css.

  • Для триальной версии:
Kanban.vue
<script>
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import '@dhx/trial-kanban/dist/kanban.css';
</script>

В этом руководстве используется триальная версия Kanban.

Настройка контейнеров и инициализация Kanban​

Чтобы отобразить Kanban с Toolbar, создайте два контейнера и вызовите конструкторы. Следующий фрагмент кода настраивает refs и инициализирует компоненты внутри mounted():

Kanban.vue
<script>
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export default {
mounted() {
// initialize the Kanban component
this.kanban = new Kanban(this.$refs.kanban_container, {});

// initialize the Toolbar component
this.toolbar = new Toolbar(this.$refs.toolbar_container, {
api: this.kanban.api, // provide Kanban inner API
// other configuration properties
});
},

unmounted() {
this.kanban.destructor(); // destroy Kanban
this.toolbar.destructor(); // destroy Toolbar
}
};
</script>

<template>
<div class="component_container">
<div ref="toolbar_container"></div>
<div ref="kanban_container" class="widget"></div>
</div>
</template>

Добавление стилей​

Добавьте стили для Kanban и контейнера в основной CSS-файл:

main.css
/* specify styles for initial page */
html,
body,
#app { /* make sure that you use the #app root container */
height: 100%;
padding: 0;
margin: 0;
}

/* specify styles for Kanban and Toolbar container */
.component_container {
height: 100%;
margin: 0 auto;
}

/* specify styles for Kanban container */
.widget {
height: calc(100% - 56px);
}

Загрузка данных​

Чтобы наполнить Kanban данными, предоставьте набор данных. Создайте файл data.js в директории src/:

data.js
export function getData() {
const columns = [
{
label: "Backlog",
id: "backlog"
},
{
label: "In progress",
id: "inprogress"
},
// ...
];

const cards = [
{
id: 1,
label: "Integration with Angular/React",
priority: 1,
color: "#65D3B3",
start_date: new Date("01/07/2021"),
users: [3, 2],
column: "backlog",
type: "feature",
},
{
label: "Archive the cards/boards",
priority: 3,
color: "#58C3FE",
users: [4],
progress: 1,
column: "backlog",
type: "feature",
},
// ...
];

const rows = [
{
label: "Feature",
id: "feature",
},
{
label: "Task",
id: "task",
}
];

return { columns, cards, rows };
}

Откройте App.vue и импортируйте набор данных. Инициализируйте значения через внутренний метод data(), затем передайте их в новый компонент <Kanban/> как props:

App.vue
<script>
import Kanban from "./components/Kanban.vue";
import { getData } from "./data";

export default {
components: { Kanban },
data() {
const { columns, cards, rows } = getData();
return {
columns,
cards,
rows
};
}
};
</script>

<template>
<Kanban :columns="columns" :cards="cards" :rows="rows"/>
</template>

Откройте Kanban.vue и примените props к объекту конфигурации Kanban:

Kanban.vue
<script>
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export default {
props: ["cards", "columns", "rows"],

mounted() {
this.kanban = new Kanban(this.$refs.kanban_container, {
cards: this.cards,
columns: this.columns,
rows: this.rows,
rowKey: "type",
// other configuration properties
});

this.toolbar = new Toolbar(this.$refs.toolbar_container, {
api: this.kanban.api,
// other configuration properties
});
},

unmounted() {
this.kanban.destructor();
this.toolbar.destructor();
}
};
</script>

<template>
<div class="component_container">
<div ref="toolbar_container"></div>
<div ref="kanban_container" class="widget"></div>
</div>
</template>

В качестве альтернативы загрузите данные после создания экземпляра с помощью setConfig() или parse() внутри mounted():

Kanban.vue
<script>
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export default {
props: ["cards", "columns", "rows"],

mounted() {
this.kanban = new Kanban(this.$refs.kanban_container, {
columns: [],
cards: [],
rows: [],
rowKey: "type",
// other configuration properties
});

this.toolbar = new Toolbar(this.$refs.toolbar_container, {
api: this.kanban.api,
// other configuration properties
});

this.kanban.setConfig({
cards: this.cards,
columns: this.columns,
rows: this.rows
});

},

unmounted() {
this.kanban.destructor();
this.toolbar.destructor();
}
};
</script>

<template>
<div class="component_container">
<div ref="toolbar_container"></div>
<div ref="kanban_container" class="widget"></div>
</div>
</template>

Компонент Kanban готов к использованию. При рендеринге элемента Kanban инициализируется с данными. Полный список поддерживаемых параметров конфигурации смотрите в справочнике по Kanban API.

Обработка событий​

Действия пользователей в Kanban вызывают события. Подпишитесь на события, чтобы реагировать на определённые действия. Полный список смотрите в справочнике по событиям Kanban.

Откройте Kanban.vue и расширьте метод mounted():

Kanban.vue
<script>
// ...
export default {
// ...
mounted() {
this.kanban = new Kanban(this.$refs.kanban_container, {});

this.kanban.api.on("add-card", (obj) => {
console.log(obj.columnId);
});
},

unmounted() {
this.kanban.destructor();
}
}
</script>

// ...

Запустите приложение, чтобы увидеть Kanban с загруженными данными на странице.

Доска DHTMLX Kanban, инициализированная в приложении Vue, с заполненными колонками и карточками

Полный пример проекта доступен на GitHub.

Перейти к основному содержимому

Интеграция с Svelte

Подсказка

Это руководство предполагает знакомство с концепциями и паттернами Svelte. Для справки обратитесь к документации Svelte.

DHTMLX Kanban совместим с Svelte. Полный пример кода доступен на GitHub.

Создание проекта​

К сведению

Перед созданием проекта установите Vite (опционально) и Node.js.

Проект на Svelte можно настроить одним из двух способов:

  • с помощью SvelteKit - рекомендуется
  • с помощью Svelte и Vite (без SvelteKit) - выполните:
npm create vite@latest

Подробнее смотрите в документации Svelte.

Установка зависимостей​

Назовите проект my-svelte-kanban-app. Перейдите в директорию приложения:

cd my-svelte-kanban-app

Установите зависимости и запустите dev-сервер с помощью одного из менеджеров пакетов:

yarn
yarn start
npm install
npm run dev

Приложение запустится на адресе localhost (например, http://localhost:3000).

Создание Kanban​

Остановите dev-сервер и установите пакет Kanban.

Шаг 1. Установка пакета​

Скачайте пробный пакет Kanban и следуйте шагам, описанным в файле README. Пробная версия доступна 30 дней.

Шаг 2. Создание компонента​

Создайте компонент Svelte, который монтирует Kanban и Toolbar. Добавьте новый файл Kanban.svelte в директорию src/.

Импорт исходных файлов​

Откройте Kanban.svelte и импортируйте исходные файлы Kanban. Пути для импорта зависят от версии пакета:

  • Для PRO-версии, установленной из локальной папки:
Kanban.svelte
<script>
import { Kanban, Toolbar } from 'dhx-kanban-package';
import 'dhx-kanban-package/dist/kanban.css';
</script>

Если пакет поставляется с минифицированными исходными файлами, импортируйте CSS-файл как kanban.min.css.

  • Для пробной версии:
Kanban.svelte
<script>
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import '@dhx/trial-kanban/dist/kanban.css';
</script>

В этом руководстве используется пробная версия Kanban.

Настройка контейнеров и инициализация Kanban​

Чтобы отобразить Kanban с Toolbar, создайте два контейнера и вызовите конструкторы. Следующий фрагмент кода привязывает контейнеры и создаёт экземпляры компонентов внутри onMount():

Kanban.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

let toolbar_container, kanban_container; // инициализация контейнеров для Kanban и Toolbar
let kanban, toolbar;

onMount(() => {
// инициализация компонента Kanban
kanban = new Kanban(kanban_container, {})

// инициализация компонента Toolbar
toolbar = new Toolbar(toolbar_container, {
api: kanban.api, // передача внутреннего API Kanban
// другие параметры конфигурации
})
});

onDestroy(() => {
kanban.destructor(); // уничтожение Kanban
toolbar.destructor(); // уничтожение Toolbar
});
</script>

<div class="component_container">
<div bind:this={toolbar_container}></div>
<div bind:this={kanban_container} style="height: calc(100% - 56px);"></div>
</div>

Загрузка данных​

Чтобы наполнить Kanban данными, предоставьте набор данных. Создайте файл data.js в директории src/:

data.js
export function getData() {
const columns = [
{
label: "Backlog",
id: "backlog"
},
{
label: "In progress",
id: "inprogress"
},
// ...
];

const cards = [
{
id: 1,
label: "Integration with Angular/React",
priority: 1,
color: "#65D3B3",
start_date: new Date("01/07/2021"),
users: [3, 2],
column: "backlog",
type: "feature",
},
{
label: "Archive the cards/boards",
priority: 3,
color: "#58C3FE",
users: [4],
progress: 1,
column: "backlog",
type: "feature",
},
// ...
];

const rows = [
{
label: "Feature",
id: "feature",
},
{
label: "Task",
id: "task",
}
];

return { columns, cards, rows };
}

Откройте App.svelte, импортируйте набор данных и передайте значения в новый компонент <Kanban/> через props:

App.svelte
<script>
import Kanban from "./Kanban.svelte";
import { getData } from "./data.js";

const { cards, columns, rows } = getData();
</script>

<Kanban {cards} {columns} {rows} />

Откройте Kanban.svelte и примените props к объекту конфигурации Kanban:

Kanban.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Kanban, Toolbar, defaultEditorShape } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export let columns;
export let cards;
export let rows;

let toolbar_container, kanban_container;
let kanban, toolbar;

onMount(() => {
kanban = new Kanban(kanban_container, {
columns,
cards,
rows,
rowKey: "type",
// другие параметры конфигурации
})

toolbar = new Toolbar(toolbar_container, {
api: kanban.api, // передача внутреннего API Kanban
// другие параметры конфигурации
})
});

onDestroy(() => {
kanban.destructor();
toolbar.destructor();
});
</script>

<div class="component_container">
<div bind:this={toolbar_container}></div>
<div bind:this={kanban_container} style="height: calc(100% - 56px);"></div>
</div>

В качестве альтернативы загрузите данные после создания экземпляра с помощью setConfig() или parse() внутри onMount():

Kanban.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Kanban, Toolbar} from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export let columns;
export let cards;
export let rows;

let toolbar_container, kanban_container;
let kanban, toolbar;

onMount(() => {
kanban = new Kanban(kanban_container, {
columns: [],
cards: [],
rows: [],
rowKey: "type",
// другие параметры конфигурации
})

toolbar = new Toolbar(toolbar_container, {
api: kanban.api, // передача внутреннего API Kanban
// другие параметры конфигурации
})

kanban.setConfig({ columns, cards, rows });
// или kanban.parse({ columns, cards, rows });
});

onDestroy(() => {
kanban.destructor();
toolbar.destructor();
});
</script>

<div class="component_container">
<div bind:this={toolbar_container}></div>
<div bind:this={kanban_container} style="height: calc(100% - 56px);"></div>
</div>

Компонент Kanban готов к работе. При рендеринге элемента Kanban инициализируется с данными. Полный список поддерживаемых свойств конфигурации смотрите в справочнике API Kanban.

Обработка событий​

Действия пользователя в Kanban вызывают события. Подписывайтесь на события для реакции на конкретные действия. Полный список смотрите в справочнике событий Kanban.

Откройте Kanban.svelte и расширьте калбэк onMount():

Kanban.svelte
<script>
// ...
let kanban;

onMount(() => {
kanban = new Kanban(kanban_container, {})

kanban.api.on("add-card", (obj) => {
console.log(obj.columnId);
});
});

onDestroy(() => {
kanban.destructor();
});
</script>

// ...

Шаг 3. Добавление Kanban в приложение​

Чтобы зарегистрировать компонент, откройте App.svelte и замените стандартный код:

App.svelte
<script>
import Kanban from "./Kanban.svelte";
import { getData } from "./data.js";

const { columns, cards, rows } = getData();
</script>

<Kanban {cards} {columns} {rows} />

Запустите приложение, чтобы увидеть заполненную доску Kanban на странице.

Доска DHTMLX Kanban, инициализированная в приложении Svelte, с заполненными колонками и карточками

Полный проект доступен на GitHub.

Перейти к основному содержимому

Интеграция с Angular

Подсказка

Данное руководство предполагает знакомство с концепциями и паттернами Angular. Для углубления знаний обратитесь к Angular documentation.

DHTMLX Kanban совместим с Angular. Полный пример кода доступен на GitHub.

Создание проекта​

К сведению

Перед созданием проекта установите Angular CLI и Node.js.

Следующая команда создаёт новый проект my-angular-kanban-app с помощью Angular CLI:

ng new my-angular-kanban-app
Примечание

При появлении соответствующего запроса отключите Server-Side Rendering (SSR) и Static Site Generation (SSG/Prerendering), чтобы проект соответствовал данному руководству.

Команда установит все необходимые инструменты. Дополнительные команды не требуются.

Установка зависимостей​

Перейдите в директорию нового приложения:

cd my-angular-kanban-app

Установите зависимости и запустите dev-сервер с помощью менеджера пакетов yarn:

yarn
yarn start

Приложение будет доступно на localhost (например, http://localhost:3000).

Создание Kanban​

Остановите dev-сервер и установите пакет Kanban.

Шаг 1. Установка пакета​

Скачайте trial Kanban package и следуйте инструкциям из файла README. Пробная версия доступна 30 дней.

Шаг 2. Создание компонента​

Создайте Angular-компонент, который монтирует Kanban и Toolbar. Создайте папку src/app/kanban/ и добавьте в неё файл kanban.component.ts.

Импорт исходных файлов​

Откройте kanban.component.ts и импортируйте исходные файлы Kanban. Путь импорта зависит от версии пакета:

  • Для PRO-версии, установленной из локальной папки:
import { Kanban, Toolbar } from 'dhx-kanban-package';
  • Для пробной версии:
import { Kanban, Toolbar } from '@dhx/trial-kanban';

В данном руководстве используется пробная версия Kanban.

Настройка контейнеров и инициализация Kanban​

Чтобы отобразить Kanban с Toolbar, задайте два контейнера и вызовите конструкторы. Следующий фрагмент кода определяет шаблон компонента, ссылки на контейнеры и создаёт экземпляры:

kanban.component.ts
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation} from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "kanban", // имя шаблона, используемого в файле "app.component.ts" как <kanban />
styleUrls: ["./kanban.component.css"], // подключение css-файла
template: `<div class = "component_container">
<div #toolbar_container></div>
<div #kanban_container class = "widget"></div>
</div>`
})

export class KanbanComponent implements OnInit, OnDestroy {
// инициализация контейнера для Toolbar
@ViewChild("toolbar_container", { static: true }) toolbar_container!: ElementRef;
// инициализация контейнера для Kanban
@ViewChild("kanban_container", { static: true }) kanban_container!: ElementRef;

private _kanban!: Kanban;
private _toolbar!: Toolbar;

ngOnInit() {
// инициализация компонента Kanban
this._kanban = new Kanban(this.kanban_container.nativeElement, {});

// инициализация компонента Toolbar
this._toolbar = new Toolbar(this.toolbar_container.nativeElement, {
api: this._kanban.api,
// другие параметры конфигурации
});
}

ngOnDestroy(): void {
this._kanban.destructor(); // уничтожение Kanban
this._toolbar.destructor(); // уничтожение Toolbar
}
}

Добавление стилей​

Добавьте стили для Kanban и контейнера. Создайте файл kanban.component.css в директории src/app/kanban/:

kanban.component.css
/* импорт стилей Kanban */
@import "@dhx/trial-kanban/dist/kanban.css";

/* стили для начальной страницы */
html,
body{
height: 100%;
padding: 0;
margin: 0;
}

/* стили для контейнера Kanban и Toolbar */
.component_container {
height: 100%;
margin: 0 auto;
}

/* стили для контейнера Kanban */
.widget {
height: calc(100% - 56px);
}

Загрузка данных​

Чтобы заполнить Kanban данными, предоставьте набор данных. Создайте файл data.ts в директории src/app/kanban/:

data.ts
export function getData() {
const columns = [
{
label: "Backlog",
id: "backlog"
},
{
label: "In progress",
id: "inprogress"
},
// ...
];

const cards = [
{
id: 1,
label: "Integration with Angular/React",
priority: 1,
color: "#65D3B3",
start_date: new Date("01/07/2021"),
users: [3, 2],
column: "backlog",
type: "feature",
},
{
label: "Archive the cards/boards ",
priority: 3,
color: "#58C3FE",
users: [4],
progress: 1,
column: "backlog",
type: "feature",
},
// ...
];

const rows = [
{
label: "Feature",
id: "feature",
},
{
label: "Task",
id: "task",
}
];

return { columns, cards, rows };
}

Откройте kanban.component.ts, импортируйте набор данных и передайте свойства данных в объект конфигурации Kanban внутри ngOnInit():

kanban.component.ts
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import { getData } from "./data"; // импорт данных
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation} from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "kanban",
styleUrls: ["./kanban.component.css"],
template: `<div class = "component_container">
<div #toolbar_container></div>
<div #kanban_container class = "widget"></div>
</div>`
})

export class KanbanComponent implements OnInit, OnDestroy {
@ViewChild("toolbar_container", { static: true }) toolbar_container!: ElementRef;
@ViewChild("kanban_container", { static: true }) kanban_container!: ElementRef;

private _kanban!: Kanban;
private _toolbar!: Toolbar;

ngOnInit() {
const { cards, columns, rows } = getData(); // инициализация данных
this._kanban = new Kanban(this.kanban_container.nativeElement, {
columns, // данные по колонкам
cards, // данные по карточкам
rows, // данные по строкам
rowKey: "type",
// другие параметры конфигурации
});

this._toolbar = new Toolbar(this.toolbar_container.nativeElement, {
api: this._kanban.api,
// другие параметры конфигурации
});
}

ngOnDestroy(): void {
this._kanban.destructor();
this._toolbar.destructor();
}
}

В качестве альтернативы загрузите данные после создания экземпляра с помощью setConfig() или parse() внутри ngOnInit():

kanban.component.ts
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import { getData } from "./data"; // импорт данных
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation} from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "kanban",
styleUrls: ["./kanban.component.css"],
template: `<div class = "component_container">
<div #toolbar_container></div>
<div #kanban_container class = "widget"></div>
</div>`
})

export class KanbanComponent implements OnInit, OnDestroy {
@ViewChild("toolbar_container", { static: true }) toolbar_container!: ElementRef;
@ViewChild("kanban_container", { static: true }) kanban_container!: ElementRef;

private _kanban!: Kanban;
private _toolbar!: Toolbar;

ngOnInit() {
const { cards, columns, rows } = getData(); // инициализация данных
this._kanban = new Kanban(this.kanban_container.nativeElement, {
columns: [],
cards: [],
rows: [],
rowKey: "type",
// другие параметры конфигурации
});

this._toolbar = new Toolbar(this.toolbar_container.nativeElement, {
api: this._kanban.api,
// другие параметры конфигурации
});

// загрузка данных с помощью метода setConfig() или parse()
this._kanban.setConfig({
columns,
cards,
rows
});
}

ngOnDestroy(): void {
this._kanban.destructor();
this._toolbar.destructor();
}
}

Компонент Kanban готов к работе. После отрисовки элемента Kanban инициализируется с данными. Полный список поддерживаемых параметров конфигурации см. в справочнике Kanban API.

Обработка событий​

Действия пользователя в Kanban вызывают события. Подписывайтесь на события, чтобы реагировать на конкретные действия. Полный список см. в справочнике событий Kanban.

Откройте kanban.component.ts и расширьте метод ngOnInit():

kanban.component.ts
// ...
ngOnInit() {
this._kanban = new Kanban(this.kanban_container.nativeElement, {});

this._kanban.api.on("add-card", (obj) => {
console.log(obj.columnId);
});
}

ngOnDestroy(): void {
this._kanban.destructor();
}

Шаг 3. Добавление Kanban в приложение​

Чтобы зарегистрировать KanbanComponent в приложении, откройте src/app/app.component.ts и замените стандартный код:

app.component.ts
import { Component } from "@angular/core";

@Component({
selector: "app-root",
template: `<kanban/>`
})
export class AppComponent {
name = "";
}

Создайте app.module.ts в директории src/app/ и объявите KanbanComponent:

app.module.ts
import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";

import { AppComponent } from "./app.component";
import { KanbanComponent } from "./kanban/kanban.component";

@NgModule({
declarations: [AppComponent, KanbanComponent],
imports: [BrowserModule],
bootstrap: [AppComponent]
})
export class AppModule {}

Откройте src/main.ts и замените существующий код:

main.ts
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { AppModule } from "./app/app.module";
platformBrowserDynamic()
.bootstrapModule(AppModule)
.catch((err) => console.error(err));

Запустите приложение, чтобы увидеть заполненную доску Kanban на странице.

Доска DHTMLX Kanban, инициализированная в приложении Angular, с заполненными колонками и карточками

Полный проект доступен на GitHub.